new;
library pgraph,tsm,optmum;
tsmset;

#include FXO.src

let string Currency = "EUR/JPY" "EUR/USD" "GBP/EUR" "GBP/USD" "JPY/USD";
let string varNames = "12M ATM";

{dt,vol} = FXO_LoadData1M(Currency,varNames);
vol = selif(vol,trunc(dt/100) .>= 1998);
dt = selif(dt,trunc(dt/100) .>= 1998);

__output = 0;
_tsm_Mcov = 2;

s = 12;
SeasonalComponent = zeros(12,5);

i = 1;
do until i > 5;

  y = vol[.,i];
  let sv = 0.01 0.2 0.5;
  {theta,stderr,Mcov,Logl} = BTSM_cml(y,s,sv,0,0);
  call SSM_build(SSM_BTSM(s,theta),0);

  a0 = y[1]|zeros(s-1,1);
  P0 = zeros(s,s);

  iter = 1;
  do until iter > 5;
    call KFiltering(y,a0,P0);
    a = KF_matrix(3);
    ssc = a[.,2];
//  asc = meanc(reshape(ssc,8,12));
    asc = FXO_Meanc(ssc);
    a0 = y[1]|rev(asc[2:12]);
    iter = iter + 1;
  endo;

  ssc1 = ssc;
  asc1 = asc;
  volatility = theta;

  proc mlProc(theta);
    local beta,asc,a0,Logl;
    beta = volatility;
    asc = theta;
    a0 = y[1]|asc;
    call SSM_build(SSM_BTSM(s,beta),0);
    call KFiltering(y,a0,P0);
    Logl = KF_ML;
    retp(Logl);
  endp;

  sv = rev(asc1[2:12]);

  __output = 1;
  _reg_PrintIters = 0;
  {theta,stderr,cov,logl} = TD_ML(&mlProc,sv);

  beta = volatility;
  asc = theta;
  a0 = y[1]|asc;
  call SSM_build(SSM_BTSM(s,beta),0);
  call KFiltering(y,a0,P0);
  a = KF_matrix(3);
  ssc = a[.,2];
// asc = meanc(reshape(ssc,8,12));
  asc = FXO_Meanc(ssc);

  SeasonalComponent[.,i] = FXO_Meanc(submat(KF_matrix(3),0,2));

  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; 
  _pltype = 6|3|1; _plwidth = 10; _pcross = 1; 
  _plctrl = 1; _pstype = 8|9|10|11|12; _pnumht = 0.18;
  _pcolor = 10|7|12|13|2;
  xtics(1,12,1,0);
  ytics(-1.5,2.0,0.5,2);
  let xlab = "Jan" "Fev" "Mar" "Apr" "May" "Jun" "Jul" "Aug" "Sep" "Oct" "Nov" "Dec";  
  asclabel(xlab,0);
  _plegstr = "EUR/JPY\000EUR/USD\000GBP/EUR\000GBP/USD\000JPY/USD";
  _plegctl = {2 4 2 5.25};
  {varNames,tmp} = token(varNames);
  xy(seqa(1,1,12),SeasonalComponent);
